﻿using System;
using System.Data.SqlClient;
using System.Runtime.ConstrainedExecution;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Visio = Microsoft.Office.Interop.Visio;

namespace ADXVisioCsharp
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("06806E36-ED24-4D81-ACC0-67771A75174C"), ProgId("ADXVisioCsharp.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxRibbonButton1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton1 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Northwind";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_9ae05b87728a44f79417dedeff1e9c32";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Organization";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton1);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_167e88f50cbf4f69bf8a19803e3b1a54";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing;
            // 
            // adxRibbonButton1
            // 
            this.adxRibbonButton1.Caption = "Create Northwind Organogram";
            this.adxRibbonButton1.Id = "adxRibbonButton_d80811d2e7db40738097c6a3501b1227";
            this.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing;
            this.adxRibbonButton1.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton1_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "ADXVisioCsharp";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaVisio;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Visio.IVApplication VisioApp
        {
            get
            {
                return (HostApplication as Visio.IVApplication);
            }
        }

        private void adxRibbonButton1_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            CreateOrganogram();
        }

        private void CreateOrganogram()
        {
            double startX = 5.433071;
            double startY = 7.559055;

            Visio.Page currpage = null;
            Visio.Documents documents = null;
            Visio.Document document = null;
            Visio.Masters masters = null;
            Visio.Master master = null;

            Visio.Shape droppedShape = null;

            try
            {
                currpage = (Visio.Page)VisioApp.ActiveWindow.Page;
                string templatePath = VisioApp.Path + "Visio\\Content\\1033\\ORGBLT_M.VSSX";

                using (SqlConnection conn = new SqlConnection("Data Source=(local);Initial Catalog=Northwind;Integrated Security=True"))
                {
                    using (SqlCommand cmd = new SqlCommand("SELECT EmployeeID,FirstName,LastName, Title,ReportsTo FROM [Employees] Order By ReportsTo", conn))
                    {
                        conn.Open();
                        SqlDataReader DataReader = cmd.ExecuteReader();
                        if (DataReader.HasRows)
                        {
                            while (DataReader.Read())
                            {
                                if (DataReader.IsDBNull(4))
                                {

                                    documents = VisioApp.Documents;
                                    document = documents.Add(templatePath);
                                    masters = document.Masters;
                                    master = masters.get_ItemU("Executive Belt");
                                    droppedShape = currpage.Drop(master, startX, startY);
                                    droppedShape.Text = String.Format("{0} {1}{2}{3}", DataReader.GetString(1), DataReader.GetString(2), Environment.NewLine, DataReader.GetString(3));
                                    if (droppedShape != null) Marshal.ReleaseComObject(droppedShape);
                                    AddSubordinate(DataReader.GetInt32(0), startX, startY, currpage, masters);
                                }
                            }
                        }
                    }
                }
            }
            finally
            {
                if (droppedShape != null) Marshal.ReleaseComObject(droppedShape);
                if (master != null) Marshal.ReleaseComObject(master);
                if (masters != null) Marshal.ReleaseComObject(masters);
                if (document != null) Marshal.ReleaseComObject(document);
                if (documents != null) Marshal.ReleaseComObject(documents);
                if (currpage != null) Marshal.ReleaseComObject(currpage);
            }
        }

        private void AddSubordinate(int employeeId, double posX, double posY, Visio.Page currpage, Visio.Masters masters)
        {
            Visio.Master master = null;
            Visio.Shape droppedShape = null;
            SqlConnection conn = null;
            SqlCommand cmd = null;

            try
            {
                using (conn = new SqlConnection("Data Source=(local);Initial Catalog=Northwind;Integrated Security=True"))
                {
                    using (cmd = new SqlCommand(String.Format("SELECT EmployeeID,FirstName,LastName, Title,ReportsTo FROM [Employees] Where ReportsTo = {0} Order By ReportsTo", employeeId), conn))
                    {
                        conn.Open();

                        SqlDataReader DataReader = cmd.ExecuteReader();
                        while (DataReader.Read())
                        {
                            if (DataReader.GetInt32(4) == 5)
                            {
                                posX = 7.795;
                                posY = 6.73;
                            }

                            master = masters.get_ItemU("Position Belt");
                            droppedShape = currpage.Drop(master, posX, posY);
                            droppedShape.Text = String.Format("{0} {1}{3}{2}", DataReader.GetString(1), DataReader.GetString(2), DataReader.GetString(3), Environment.NewLine);

                            if (droppedShape != null) Marshal.ReleaseComObject(droppedShape);
                            AddSubordinate(DataReader.GetInt32(0), posX, posY, currpage, masters);
                        }
                    }
                }
            }
            finally
            {
                if (droppedShape != null) Marshal.ReleaseComObject(droppedShape);
                if (master != null) Marshal.ReleaseComObject(master);
            }
        }

    }
}

