﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Visio = Microsoft.Office.Interop.Visio
Imports System.Data.SqlClient

'Add-in Express Add-in Module
<GuidAttribute("3B26D1A0-16EA-4522-8AD9-AE42CD9ED59D"), ProgIdAttribute("ADXVisioVBNet.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents AdxRibbonButton1 As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents AdxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents AdxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.AdxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.AdxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.AdxRibbonButton1 = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        '
        'AdxRibbonTab1
        '
        Me.AdxRibbonTab1.Caption = "Northwind (VB.Net)"
        Me.AdxRibbonTab1.Controls.Add(Me.AdxRibbonGroup1)
        Me.AdxRibbonTab1.Id = "adxRibbonTab_a9fdc996bc5a4947949e8967cdc7c238"
        Me.AdxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing
        '
        'AdxRibbonGroup1
        '
        Me.AdxRibbonGroup1.Caption = "Organization"
        Me.AdxRibbonGroup1.Controls.Add(Me.AdxRibbonButton1)
        Me.AdxRibbonGroup1.Id = "adxRibbonGroup_07daac7666f14440996c0e3c80bb788a"
        Me.AdxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing
        '
        'AdxRibbonButton1
        '
        Me.AdxRibbonButton1.Caption = "Create Northwind Organogram"
        Me.AdxRibbonButton1.Id = "adxRibbonButton_43be464bb5704fe4863e14b87b16e2ce"
        Me.AdxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrVisioDrawing
        '
        'AddinModule
        '
        Me.AddinName = "ADXVisioVBNet"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaVisio

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property VisioApp() As Visio.IVApplication
        Get
            Return CType(HostApplication, Visio.IVApplication)
        End Get
    End Property



    Private Sub CreateOrganogram()
        Dim startX As Double = 5.433071
        Dim startY As Double = 7.559055

        Dim currpage As Visio.Page = Nothing
        Dim documents As Visio.Documents = Nothing
        Dim document As Visio.Document = Nothing
        Dim masters As Visio.Masters = Nothing
        Dim master As Visio.Master = Nothing

        Dim droppedShape As Visio.Shape = Nothing

        Try
            currpage = DirectCast(VisioApp.ActiveWindow.Page, Visio.Page)
            Dim templatePath As String = VisioApp.Path + "Visio\Content\1033\ORGBLT_M.VSSX"

            Using conn As New SqlConnection("Data Source=(local);Initial Catalog=Northwind;Integrated Security=True")
                Using cmd As New SqlCommand("SELECT EmployeeID,FirstName,LastName, Title,ReportsTo FROM [Employees] Order By ReportsTo", conn)
                    conn.Open()
                    Dim DataReader As SqlDataReader = cmd.ExecuteReader()
                    If DataReader.HasRows Then
                        While DataReader.Read()
                            If DataReader.IsDBNull(4) Then

                                documents = VisioApp.Documents
                                document = documents.Add(templatePath)
                                masters = document.Masters
                                master = masters.ItemU("Executive Belt")
                                droppedShape = currpage.Drop(master, startX, startY)
                                droppedShape.Text = [String].Format("{0} {1}{2}{3}", DataReader.GetString(1), DataReader.GetString(2), Environment.NewLine, DataReader.GetString(3))
                                If droppedShape IsNot Nothing Then
                                    Marshal.ReleaseComObject(droppedShape)
                                End If
                                AddSubordinate(DataReader.GetInt32(0), startX, startY, currpage, masters)
                            End If
                        End While
                    End If
                End Using
            End Using
        Finally
            If droppedShape IsNot Nothing Then
                Marshal.ReleaseComObject(droppedShape)
            End If
            If master IsNot Nothing Then
                Marshal.ReleaseComObject(master)
            End If
            If masters IsNot Nothing Then
                Marshal.ReleaseComObject(masters)
            End If
            If document IsNot Nothing Then
                Marshal.ReleaseComObject(document)
            End If
            If documents IsNot Nothing Then
                Marshal.ReleaseComObject(documents)
            End If
            If currpage IsNot Nothing Then
                Marshal.ReleaseComObject(currpage)
            End If
        End Try
    End Sub


    Private Sub AddSubordinate(employeeId As Integer, posX As Double, posY As Double, currpage As Visio.Page, masters As Visio.Masters)
        Dim master As Visio.Master = Nothing
        Dim droppedShape As Visio.Shape = Nothing
        Dim conn As SqlConnection = Nothing
        Dim cmd As SqlCommand = Nothing

        Try
            conn = New SqlConnection("Data Source=(local);Initial Catalog=Northwind;Integrated Security=True")
            cmd = New SqlCommand([String].Format("SELECT EmployeeID,FirstName,LastName, Title,ReportsTo FROM [Employees] Where ReportsTo = {0} Order By ReportsTo", employeeId), conn)
            conn.Open()

            Dim DataReader As SqlDataReader = cmd.ExecuteReader()
            While DataReader.Read()
                If DataReader.GetInt32(4) = 5 Then
                    posX = 7.795
                    posY = 6.73
                End If

                master = masters.ItemU("Position Belt")
                droppedShape = currpage.Drop(master, posX, posY)
                droppedShape.Text = [String].Format("{0} {1}{3}{2}", DataReader.GetString(1), DataReader.GetString(2), DataReader.GetString(3), Environment.NewLine)

                If droppedShape IsNot Nothing Then
                    Marshal.ReleaseComObject(droppedShape)
                End If
                AddSubordinate(DataReader.GetInt32(0), posX, posY, currpage, masters)
            End While

        Finally
            If droppedShape IsNot Nothing Then
                Marshal.ReleaseComObject(droppedShape)
            End If
            If master IsNot Nothing Then
                Marshal.ReleaseComObject(master)
            End If
        End Try
    End Sub


    Private Sub AdxRibbonButton1_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles AdxRibbonButton1.OnClick
        CreateOrganogram()
    End Sub
End Class

